<?php

require_once mb_path("/lib-action/action.php");

require_once(MB_LIBPATH.'/lib-tk/include/sso/post_binding.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/Tokens.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/url.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/SSOSettings.php');

/**
 * This action displays a login form to the user. This instance of this action is hit whenever an admin user's session
 * has expired. To alleviate frustration, when posting to the admin/login/LoginResponse action, the redirectActionID 
 * and redirectActionFile request parameters should also be passed, so that LoginResponse can redirect accordingly. This 
 * is not a security issue, because the admin is required to authenticate before redirect, and even if they hit the 
 * given action file and action ID, they'd be denied access unless their user is allowed access by the system.
 */
class InitSSOLogin extends MB_Action {

    function __construct() {
        parent::MB_Action();
        $this->stringRep = __CLASS__;
    }
    
    /**
     * The main method of this class that executes the ShowLogin action, and returns success or failure.
     *
     * @return  int  1 if this action executed successfully, or 0 if otherwise.
     */
    function execute() {
        parent::execute();
        $this->sendSamlAuthnRequest();
        return true;
    }
    
    function sendSamlAuthnRequest() {
        $ssoRegRequest = SSOSettings::getRequestProps();
        $ssoRegProps = SSOSettings::getProps();

        $returnUrl = absolute_url($_SERVER);

        // TODO (bug, sso) If SP is registered by IP address by has also DNS name this URL will
        //      refer that name and response destination will be rejected by SSO server.
        //      Workaround: register by hostname if host is in DNS.
        $samlXml = new saml_Tokens();
        SAMLUtil::sendMessage(
            SSOSettings::getUserIDPApiUrl() . '/relay',
            $samlXml->createAuthnRequest(null, $returnUrl, $ssoRegProps['sp_id']),
            $returnUrl,
            $ssoRegProps['sp_pkey'] );
        // Response will be handled in "ReceiveSSOLoginStatus"
    }
} // InitSSOLogin

?> 