<?php

require_once mb_path("/lib-action/action.php");

require_once(MB_LIBPATH.'/lib-tk/include/sso/post_binding.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/Tokens.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/url.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/SSOSettings.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/SAMLUtil.php');

/**
 * Sends SSO logout request. Response will be handled in HandleSSOAPIRequest.
 */
class InitSSOLogout extends MB_Action {
    function InitSSOLogout() {
        parent::MB_Action();
        $this->stringRep = __CLASS__;
    }
    
    /**
     * The main method of this class that executes the ShowLogin action, and returns success or failure.
     *
     * @return  int  1 if this action executed successfully, or 0 if otherwise.
     */
    function execute() {
        global $CONF;
        parent::execute();
        $this->sendSamlLogoutRequest();
        return true;
    }
    
    /*
     * SAML Authentiation request.
     */
    function makeSamlLogoutRequest($userId, $returnUrl, $spId, $spPrivKey) {
        $samlXml = new saml_Tokens();
        return SAMLUtil::packMessage(
            $samlXml->createLogOutRequest($returnUrl, $spId, $userId, null),
            $spPrivKey );
    }
    
    
    function sendSamlLogoutRequest() {
        global $CONF;
        $user = $CONF["user"]["username"];
        if ($user) {        
            $ssoRegRequest = SSOSettings::getRequestProps();
            $ssoRegProps = SSOSettings::getProps();
            $tokens = new saml_Tokens();
            $destinationUrl = SSOSettings::getUserIDPApiUrl() . '/SAML';
            SAMLUtil::sendMessage(
                $destinationUrl,
                $tokens->createLogOutRequest($destinationUrl, $ssoRegProps['sp_id'], $user, null),
				null,
                $ssoRegProps['sp_pkey'] );
            // Response will be handled in "HandleSSOAPIRequest"
        } else {
            redirect('dashboard.php', getActionID('ShowDashboard'));
        }
    }
    
} // InitSSOLogout

?>