<?php
// $Id: ShowLogin.php 12985 2008-07-09 20:02:41Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once mb_path("/lib-action/action.php");

require_once(MB_LIBPATH.'/lib-tk/include/sso/util.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/Xml.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/Tokens.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/url.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/PostData.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/SAMLUtil.php');
require_once(MB_LIBPATH.'/lib-tk/include/sso/SSOUtil.php');

/**
 * This action receives SSO login status message from SSO server.
 */
class ReceiveSSOLoginStatus extends MB_Action {

    function ReceiveSSOLoginStatus() {
        parent::MB_Action();
        $this->stringRep = __CLASS__;
    }

    function getAdminID($name) {
        $h =& new QueryMaster('select', getDBCol('adminID'));
        $h->addTables('admins');
        $h->addAndClause(getDBCol('adminUsername'), '=', $name);
        $data = $h->getRow();
        if (count($data)) {
            return $data[getDBCol('adminID')];
        } else {
            return null;
        }
    }

    function getClientID($name) {
        $h =& new QueryMaster('select', "client_contacts.client_contact_id");
        //$h->addTables('client_contacts');
		$h->addJoin("clients", "client_id", "client_contacts");
        $h->addAndClause("client_contacts.contact_username", "=", $name);
		$h->addAndClause("client_contacts.contact_active", "=", 1, "i");
		$h->addAndClause("clients.client_active", "=", 1, "i");
		$h->addAndClause("clients.client_status", "=", getAPIStatusID("client", "active"), "i");

        $data = $h->getRow();
        if (count($data)) {
            return $data[getDBCol('clientContactID')];
        } else {
            return null;
        }
    }

    function parseSamlResponse($response, $relayState) {
        if (!$response) {
            return null;
        }
        $domXml = SAMLUtil::unpackMessage($response);
        $samlTokens = new saml_Tokens();
        $account_id = $samlTokens->getNameId($domXml);
        if ($account_id) {
            // XXX (security) sign relay state when sending request and verify signature here
			$return_url = $relayState;
            $assertion_id = $samlTokens->getAssertionID($domXml);
            $attributes = correctArray($samlTokens->getAttributes($domXml));
            return array($account_id['NameID'],  $assertion_id, $return_url, $attributes);
        } else {
            $status = $samlTokens->getSamlStatus($domXml);
            throw new Exception($status['message']);
        }
    }

    function openSession(
		$userId,
		$userType,
		$assertionId
	) {
	    assert('$userId');
	    assert('in_array($userType, array(1, 2))');
        global $CONF;
        /*
         * We could use assertion id $assertionId as session identifier but then we need
         * to re-open existing session with same identifier or delete session's
         * record to prevent session identifier conflicts.
         */
        $assertionId = $assertionId; // Make ZendAnalyzer happy
        $sessionId = make_new_id();

        // XXX (db, sso, correctness) Following select and insert should be done within single transaction.
        $qh =& new QueryMaster('select');
        $qh->addTables('sessions');
        $qh->addAndClause('session_id', '=', $sessionId, 's');
        $qh->addAndClause('session_active', '=', 1, 'i');
        $res = $qh->getResults(1);
        if ($res === false) {
            throw new Exception(list_to_string($qh->getErrors(), false));
        }
        // Do not open session with this identifier
        if (count($res) == 0) { // Do not duplicate session with the ID
            $ih =& new QueryMaster('insert', 'sessions');
            $ih->addParam('session_id', $sessionId);
            $ih->addParam('user_id', $userId, 'i');
            $ih->addParam('user_type', $userType, 'i');
            $ih->addParam('session_active', 1, 'i');
            $ih->addParam('session_date_accessed', time(), 'i');
            $ih->addParam('session_date_created', time(), 'i');
            $ih->addParam(
                'session_date_expired',
                time() + $CONF['system']['sessions']['adminSessionLength'],
                'i' );
            $ih->addParam('session_ip', ip2long($_SERVER['REMOTE_ADDR']), 'i');
            $ih->execute();
            if ($ih->getNumErrors() != 0) {
                throw new Exception('Can not insert session record (session_id=$sessionId) into database.');
            }
        }
        return $sessionId;
    }

    function linkSessionToClientContact($sessionId, $contactId) {
        $h =& new QueryMaster('insert', 'client_contact_session_rel');
        $h->addParam(getDBCol('clientContactID'), $contactId, 'i');
        $h->addParam(getDBCol('sessionID'), $sessionId);
        if(!$h->execute()) {
            $msg = 'Failed to relate new session with client login.';
            $this->addError(TRANS_MBAPIERROR, $msg);
            // Remove new session
            $h =& new QueryMaster('delete', 'sessions');
            $h->addAndClause(getDBCol('sessionID'), '=', $sessionId);
            $h->execute();
            throw new Exception($msg);
        }
    }

    /**
     * The main method of this class that executes the ShowLogin action, and returns success or failure.
     *
     * @return int  1 if this action executed successfully, or 0 otherwise.
     */
    function execute() {
        global $CONF;
        parent::execute();

        $response = getAt($_POST, 'SAMLResponse');
        if (!$response) {
            return false;
        }

        $rootPath = get_root_path();

        try {
            $relayState = getAt($_POST, 'RelayState');
			$userId = NULL;
            list(
				$user,
				$assertionId,
				$ret_url,
				$attributes
			) = $this->parseSamlResponse($response, $relayState);

			SSOUtil::setAssociatedFIName($attributes['associated_fi_name']);

			// XXX (refactoring) Split this into 2 classes (with separate utility class or common parent)
			switch (APP_CURRENT) {
				case 'app-modernbill-admin':
					$userType = 2;
					$userId = $this->getAdminID($user);
		            $sessionId = $this->openSession(
						$userId,
						$userType,
						$assertionId
					);
		            $_REQUEST['adminID'] = $userId;
					break;
				case 'app-modernbill-client':
					$userType = 1;
					$userId = $this->getClientID($user);
		            $sessionId = $this->openSession(
						$userId,
						$userType,
						$assertionId
					);
					$this->linkSessionToClientContact($sessionId, $userId);
		            $_REQUEST['clientID'] = $userId;
					break;
				default:
				    throw new Exception('Unexpected sub-application type: '.APP_CURRENT, 500);
			}

			// PPB is already signed in SSO and has local session.

			$CONF['user']['id'] = $userId;
			$CONF['user']['type'] = $userType;
            $CONF['user']['sessionID'] = $sessionId;

            /*
             * This is be used in 'redirect' function. We can not pass it with 3-rd parameter
             * to redirect as it gets overridden later in redirect's code
             */
            $_REQUEST['sid'] = $sessionId;

            $ret_url_args = null;
            parse_str(parse_url($ret_url, PHP_URL_QUERY), $ret_url_args);
            if ($ret_url_args['action']) {
                redirect($ret_url);
            } else {
                redirect($rootPath . 'dashboard.php', getActionID('ShowDashboard'));
            }
        } catch (Exception $e) {
            dbg($e->getMessage());
            redirect($rootPath.'login.php', getActionID('SelectSSOLoginMethod'), array(
				'msg' => $e->getMessage()
			));
        }
        return true;
    }

} // ReceiveSSOLoginStatus.php

?>