<?php
// $Id: GetBans.php 6182 2006-04-13 16:40:38Z kbailey $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../lib-tk/shield.php";
require_once mb_path("/lib-mbapi/Command.php");

/**
	Command to get accounting totals data.
	<!-- @type  group
		MBAPI request document root.
	-->
	<mbapi>
		<!-- @type  string
			Required. The string [[GetClientBalances]].
		-->
		<command></command>
		<!-- @type  boolean
	Whether to show an XML header in the results.
		-->
		<showXMLHeader></showXMLHeader>
		<!-- @type  group
	[[GetClientBalances]] parameters.
		-->
		<params>
			<!-- @type  int
	Whether to return client CRM data as well as balances.
			-->
			<returnClientData></returnClientData>

			<!-- @type  int
	Whether to return the date of the oldest invoice that is due.
			-->
			<getOldestDueDate></getOldestDueDate>

			<!-- @type  int
	Limit data to these clientID's.
			-->
			<clientID></clientID>

			<!-- @type  int
	Limit data to clients matching these GUIDs.
			-->
			<GUID></GUID>

			<!-- @type  int
	Limit data to clients matching these masterAccountIDs.
			-->
			<masterAccountID></masterAccountID>

			<!-- @type  string
	Get only data from these ledger accounts. ex. accounts_receivable and revenue and deferred_revenue
			-->
			<ledgerAccount></ledgerAccount>

		</params>
	</mbapi>
	<!-- @type  group
		MBAPI response document root.
	-->
	<mbapi>
		<!-- @type  group
	Contains result meta data: data about the result itself.
		-->
		<header>
			<!-- @type  hex
	A session ID that may be used for authentication instead of a remote access hash.
			-->
			<remoteSessionID></remoteSessionID>
			<!-- @type  int
	The number of errors that occured.
			-->
			<errorCount></errorCount>
			<!-- @type  group
	Contains any errors that occured.
			-->
			<errors>
				<!-- @type  group
	Contains information relating to a single error. Occurs [[header errorCount]] times.
				-->
				<error>
					<!-- @type  string
	The title of the error.
					-->
					<title></title>
					<!-- @type  string
	The error message.
					-->
					<message></message>
				</error>
			</errors>
			<!-- @type  int
	The number of results that have been returned. For [[Get*]] commands.
			-->
			<numResults></numResults>
			<!-- @type  int
	The number of rows that have been affected. For [[Set*]] commands.
			-->
			<numAffectedRows></numAffectedRows>
		</header>
		<!-- @type  group
	Contains any results.
		-->
		<results>
			<!-- @type  group
	Contains all ban results.
			-->
			<clients>
				<!-- @type  group
	Contains all results for a single ban. Occurs [[header numResults]]
	times.
				-->
				<client>
					<!-- @type  int
	The clientID of the client this data is for.
					-->
					<clientID></clientID>

					<!-- @type  string
	If this record was looked up by GUID, then the GUID will be returned.
					-->
					<GUID></GUID>

					<!-- @type  group
	Accounts receivable amounts in each currency.
					-->
					<accounts_receivable>

						<!-- @type  group
	A wrapper for currency  ex. <USD> ... </USD>
				-->
						<CURRENCYIDHERE>
							<!-- @type   float
	The debits in this account.
							-->
							<debits></debits>
		
							<!-- @type   float
	The credits in this account.
							-->
							<credits></credits>
		
						</CURRENCYIDHERE>


					</accounts_receivabe>
				</ban>
			</bans>
		</results>
	</mbapi>
 *
 * @package modernbill
 * @subpackage mbapi
 * @version 1.0
 * @author Kris Bailey
 */
class MBAPI_GetClientBalancesCommand extends MBAPI_Command {
	/**
	 *
	 */
	function execute() {
		global $CONF, $db;
		parent::execute();

		$clientIDs = array();
		$GUIDMAP = array();
		$masterAccountIDMAP = array();
		if ($this->params["GUID"][0]){
			// we have at least one GUID, so lets use it....
			foreach ($this->params["GUID"] as $k=>$g){
				if (!$g){ // remove blank ones
					unset($this->params["GUID"][$k]);
				}
			}
			$h =& new QueryMaster("clients.client_id");
			$h->addJoin("packages", "client_id", "clients");
			$h->addJoin("package_attributes", "package_id", "packages");
			$h->addColumns("package_attributes.package_attribute_value");
			$h->addAndClause("package_attributes.package_attribute_name", "=", "guid", "s");
			$h->addAndClause("package_attributes.package_attribute_value", "=", $this->params["GUID"], "s");
			$results = $h->getResults();
			foreach ((array)$results as $r){
				$GUIDMAP[$r["client_id"]] = $r["package_attribute_value"];
				$clientIDs[$r["client_id"]] = 1;
			}
		}

		if ($this->params["masterAccountID"][0]){
			// we have at least one GUID, so lets use it....
			foreach ($this->params["masterAccountID"] as $k=>$g){
				if (!$g){ // remove blank ones
					unset($this->params["masterAccountID"][$k]);
				}
			}
			$h =& new QueryMaster("clients.client_id");
			$h->addJoin("packages", "client_id", "clients");
			$h->addJoin("package_attributes", "package_id", "packages");
			$h->addColumns("package_attributes.package_attribute_value");
			$h->addAndClause("package_attributes.package_attribute_name", "=", "masterAccountID", "s");
			$h->addAndClause("package_attributes.package_attribute_value", "=", $this->params["masterAccountID"], "s");
			$results = $h->getResults();
			foreach ((array)$results as $r){
				$masterAccountIDMAP[$r["client_id"]] = $r["package_attribute_value"];
				$clientIDs[$r["client_id"]] = 1;
			}
		}

		if ((int)$this->params["clientID"][0]){
			foreach ((array)$this->params["clientID"] as $cid){
				$clientIDs[$cid] = 1;
			}
		}

		if (!$this->params["ledgerAccount"][0]){
			$accounts = array("accounts_receivable");
		} else {
			$accounts = array();
			foreach ((array)$this->params["ledgerAccount"] as $la){
				if ($la) $accounts[] = $la;
			}
		}

		$h =& new QueryMaster("accounting_ledger_accounts.ledger_account_id");
		$h->addColumns("accounting_ledger_accounts.ledger_account_name");
		$h->addColumns("accounting_ledger_accounts.ledger_account_type");
		foreach ($accounts as $a){
			$h->addOrClause("accounting_ledger_accounts.ledger_account_name", "=", $a, "s");
		}
		$results = $h->getResults();

		$ledgerAccounts = array();
		$ledgerAccountTypes = array();
		foreach ((array)$results as $r){
			$ledgerAccounts[$r["ledger_account_id"]] = $r["ledger_account_name"];
			$ledgerAccountTypes[$r["ledger_account_id"]] = $r["ledger_account_type"];
		}

		$clientIDs = array_keys($clientIDs);


		if ((int)$this->params["getOldestDueDate"][0]){
			$h =& new QueryMaster("MIN(invoices.invoice_date_due) as invoice_date_due");
			$h->addColumns("invoices.client_id");
			$h->addAndClause("invoices.client_id", "=", $clientIDs, "i");
			$h->addAndClause("invoices.invoice_status", "=", array(
				getAPIStatusID("invoice", "due"),
				getAPIStatusID("invoice", "declined"),
				getAPIStatusID("invoice", "errored"),
			), "i");
			$h->addGroupByColumns("invoices.client_id");
			$dates = $h->getResults();
			$invoiceDates = array();
			foreach ((array)$dates as $d){
				$invoiceDates[$d["client_id"]] = $d["invoice_date_due"];
			}
		}

		if ((int)$this->params["returnClientData"][0]){
			$h =& new QueryMaster("clients.*");
			$h->addColumns("client_contacts.*");
			$h->addJoin("client_contacts", "client_id", "clients");
			$h->addAndClause("client_contacts.contact_primary", "=", 1, "i");
			$h->addJoin("accounting_general_ledger", "client_id", "clients");
			$h->addGroupByTables("clients");
			$h->addGroupByTables("client_contacts");
		} else {
			$h =& new QueryMaster("accounting_general_ledger.client_id");
			$h->addGroupByColumns("accounting_general_ledger.client_id");
		}

		$h->addColumns("SUM(accounting_general_ledger.general_ledger_debit_amount) as debits");
		$h->addColumns("SUM(accounting_general_ledger.general_ledger_credit_amount) as credits");
		$h->addColumns("accounting_general_ledger.currency_id");
		$h->addColumns("accounting_general_ledger.ledger_account_id");
		$h->addAndClause("accounting_general_ledger.ledger_account_id", "=", array_keys($ledgerAccounts), "i");
		$h->addAndClause("accounting_general_ledger.client_id", "=", $clientIDs, "i");
		$h->addGroupByColumns("accounting_general_ledger.currency_id");
		$h->addGroupByColumns("accounting_general_ledger.ledger_account_id");

		$h->addOrderByColumns("accounting_general_ledger.client_id", "ASC");

		$results = $h->getResults();

		$grouped = array();

		foreach ($results as $r){
			$grouped[$r["client_id"]]["clientID"] = $r["client_id"];

			if ($GUIDMAP[$r["client_id"]]){
				$grouped[$r["client_id"]]["GUID"] = $GUIDMAP[$r["client_id"]];
			}
			if ($masterAccountIDMAP[$r["client_id"]]){
				$grouped[$r["client_id"]]["masterAccountID"] = $masterAccountIDMAP[$r["client_id"]];
			}
			if ((int)$this->params["returnClientData"][0] && !(int)$grouped[$r["client_id"]]["clientContactID"]){
				foreach ((array)$r as $key=>$value){
					if (!in_array($key, array("debits", "credits", "ledger_account_id", "currency_id", "client_id"))){
						$grouped[$r["client_id"]][getDBXMLCol($key)] = $value;
					}
				}
			}
			if ((int)$this->params["getOldestDueDate"][0] && !(int)$grouped[$r["client_id"]]["invoiceDateDue"]){
				$grouped[$r["client_id"]]["invoiceDateDue"] = $invoiceDates[$r["client_id"]];
//				$grouped[$r["client_id"]]["invoiceDateDueReadable"] = date("m-d-Y g:i a", $invoiceDates[$r["client_id"]]);
			}

			$grouped[$r["client_id"]][$ledgerAccounts[$r["ledger_account_id"]]][$r["currency_id"]] = array(
				"debits" => $r["debits"],
				"credits" => $r["credits"],
				"balance" => in_array($ledgerAccountTypes[$r["ledger_account_id"]], array(1, 5, 6)) ? $r["debits"] - $r["credits"] : $r["credits"] - $r["debits"],
			);
		}
		
		$this->setXMLData(array("clients"=>array("client"=>array_values($grouped))));
		return $this->getXMLData();
	}
} // MBAPI_GetBansCommand

